/*
 * effect_rack_view.h - view for effectChain-model
 *
 *
 */

#ifndef _INSTRUMENT_SHIFT_VIEW_H
#define _INSTRUMENT_SHIFT_VIEW_H

#include <QtGui/QDialog>
#include <QtGui/QWidget>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>

#include "EffectChain.h"//-
#include "ModelView.h"
#include "lmms_basics.h"
#include "Harmony.h"

class QScrollArea;
class QVBoxLayout;

class EffectView;
class groupBox;

class QLineEdit;

class InstrumentShiftView : public QWidget, public ModelView
{
	Q_OBJECT
public:
	InstrumentShiftView( InstrumentTrack *track, QWidget * _parent = NULL );
	virtual ~InstrumentShiftView();

	inline void setInstrumentTrack( InstrumentTrack * _track ) {
		m_track = _track;
	}
	void reset();
//?	inline int getFrequencyShiftNum() { return frequencyShiftNum; }
//?	inline int getFrequencyShiftDen() { return frequencyShiftDen; }

public slots:
	void clearViews();
	void numChanged( const QString & _new_value );
	void denChanged( const QString & _new_value );


private slots:
	virtual void update();


signals:
	void currentPatternChanged();


private:
	virtual void modelChanged();

	QVBoxLayout * m_mainLayout;

	InstrumentTrack *m_track;
//-	QVector<QRadioButton *> harmonicScaleButtons;
	QLineEdit *numEdit;
	QLineEdit *denEdit;
//?	int frequencyShiftNum, frequencyShiftDen;
} ;

#endif
