/*
 * InstrumentShiftView.cpp - view for effectChain model
 *
 */

#include "stdio.h"
#include <iostream>
using namespace std;

#include <QtCore/QQueue>
#include <QtGui/QApplication>
#include <QtGui/QLayout>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QScrollArea>
#include <QtGui/QVBoxLayout>
#include <QtGui/QLineEdit>
#include <QtGui/QIntValidator>

#include "EffectSelectDialog.h"//-
#include "EffectView.h"//-
#include "group_box.h"
#include "InstrumentTrack.h"
#include "InstrumentShiftView.h"


InstrumentShiftView::InstrumentShiftView( InstrumentTrack *_track, QWidget * _parent ) :
	QWidget( _parent ),
	ModelView( NULL, this ),
	m_track( _track )
{
	setFixedSize( 250, 250 );

	m_mainLayout = new QVBoxLayout( this );
	m_mainLayout->setSpacing( 0 );
	m_mainLayout->setMargin( 5 );

	QLabel *titleLabel = new QLabel("Frequency shift");
	m_mainLayout->addWidget( titleLabel );

	int
		frequencyShiftNum = m_track->getFrequencyShiftNum(),
		frequencyShiftDen = m_track->getFrequencyShiftDen();

cout << "InstrumentShiftView::InstrumentShiftView: frequencyShift: "<<frequencyShiftNum<<'/'<<frequencyShiftDen<<endl;//-
	numEdit = new QLineEdit(QString::number(frequencyShiftNum),this);
	numEdit->setValidator(new QIntValidator(numEdit));
	m_mainLayout->addWidget( numEdit );
	connect(numEdit,SIGNAL(textChanged(const QString &)),this,SLOT(numChanged(const QString &)));

	denEdit = new QLineEdit(QString::number(frequencyShiftDen),this);
	denEdit->setValidator(new QIntValidator(denEdit));
	m_mainLayout->addWidget( denEdit );
	connect(denEdit,SIGNAL(textChanged(const QString &)),this,SLOT(denChanged(const QString &)));

	QPushButton * OKButton = new QPushButton( this );
	OKButton->setText( tr( "OK" ) );
	OKButton->move( 8, 210 );
	m_mainLayout->addWidget( OKButton );//?
	connect( OKButton, SIGNAL( clicked() ), this, SLOT( update() ) );

//-	setModel( _model );
}


InstrumentShiftView::~InstrumentShiftView()
{
	clearViews();
}

void InstrumentShiftView::clearViews()
{
}

void InstrumentShiftView::reset() {
	int 
		num=m_track->getFrequencyShiftNum(),
		den=m_track->getFrequencyShiftDen();
cout << "InstrumentShiftView::reset:freqShift:m_track="<<m_track<<",num="<<num<<",den="<<den<<"\n";cout.flush();//-
//?	m_track->setFrequencyShift(frequencyShiftNum,frequencyShiftDen);
	numEdit->setText(QString::number(num));
	denEdit->setText(QString::number(den));
}

void InstrumentShiftView::update()
{
	reset();
	emit( currentPatternChanged() );
	QWidget::update();
}

void InstrumentShiftView::numChanged( const QString & _new_val )
{
	int frequencyShiftNum = _new_val.toInt();
	cout << "InstrumentShiftView::numChanged:new_val="<<_new_val.toAscii().constData()<<"' = "<<frequencyShiftNum<<"\n";//-

	m_track->setFrequencyShiftNum(frequencyShiftNum);
}

void InstrumentShiftView::denChanged( const QString & _new_val )
{
	int frequencyShiftDen = _new_val.toInt();
	cout << "InstrumentShiftView::denChanged:new_val="<<_new_val.toAscii().constData()<<"' = "<<frequencyShiftDen<<"\n";//-
	m_track->setFrequencyShiftDen(frequencyShiftDen);
}





void InstrumentShiftView::modelChanged()
{
	clearViews();
//-	m_effectsGroupBox->setModel( &fxChain()->m_enabledModel );
//-	connect( fxChain(), SIGNAL( aboutToClear() ),
//-			this, SLOT( clearViews() ) );
	update();
}



#include "moc_InstrumentShiftView.cxx"

